﻿using System;
using System.Collections.Generic;
using System.Text;

namespace IST_tow_methods
{
    class IST_tool
    {

        String br = Convert.ToChar(13).ToString() + Convert.ToChar(10).ToString();

        #region 驗證 Independent
        /// <summary>
        /// 驗證是否為 Independent
        /// </summary>
        /// <param name="ist">整個結果的表</param>
        /// <param name="nnn"> n 值</param>
        /// <returns></returns>
        public Boolean isIndependent(int[][] ist, int nnn, int root)
        {
            Boolean[] temnode = new Boolean[Convert.ToInt32(Math.Pow(2, nnn))];


            for (int i = 0; i < ist[0].Length; i++)     //點的數量
            {
                for (int allto0 = 0; allto0 < temnode.Length; allto0++)
                    temnode[allto0] = false;  //規0
                for (int j = 0; j < ist.Length; j++)
                {
                    if (!findpath(ist, ref temnode, i, j, root))
                        return false;
                }
            }


            return true;
        }

        /// <summary>
        /// 驗證路徑
        /// </summary>
        /// <param name="ist">整個樹</param>
        /// <param name="aaa">某個點的紀錄表</param>
        /// <param name="index">當前要記錄的點</param>
        /// <param name="thetn">第幾棵樹</param>
        /// <param name="theroot">root的點</param>
        /// <returns></returns>
        public Boolean findpath(int[][] ist, ref Boolean[] aaa, int index, int thetn, int theroot)
        {

            if (index != theroot)  //root 不用管他
            {
                if (!aaa[ist[thetn][index]])   //紀錄表的
                {
                    if (ist[thetn][index] != theroot)
                        aaa[ist[thetn][index]] = true;  //記為True
                    findpath(ist, ref aaa, ist[thetn][index], thetn, theroot);
                }
                else
                {
                    System.Windows.Forms.MessageBox.Show("It is not Independent." + br + "(" + index.ToString() + ")");
                    return false;
                }
            }

            return true;
        }
        #endregion


    }
}
